package main

import "fmt"

type carta struct {
  valore int  /* 0=2, 1=3, 2=4, ..., 12=A; in questo modo indici minori
                 hanno un valore inferiore */
  seme int    /* 0=picche, ..., 3=cuori; in questo modo indici minori
                 sono semi di valore inferiore */
}

func cartaStr(c carta) string {
  valore2nome := [...]string{"2", "3", "4", "5", "6", "7", "8", "9",
    "10", "J", "Q", "K", "A"}
  seme2nome := [...]string{"\u2660", "\u2663", "\u2666", "\u2665"}

  return valore2nome[c.valore] + seme2nome[c.seme]
}

/* Restituisce un mazzo completo di carte */
func mazzo() []carta {
  var mazzo []carta
  for s := 0; s < 4; s++ {
    for v := 0; v < 13; v++ {
      c := carta{valore: v, seme: s}
      mazzo = append(mazzo, c)
    }
  }
  return mazzo
}

func main() {
  m := mazzo()
  for _, c := range m {
    fmt.Println(cartaStr(c))
  }
}
